<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: gluon - A toolkit of simple algorithms, data structures and utilities in C.</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">gluon - A toolkit of simple algorithms, data structures and utilities in C. </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>Full <a href="https://u.westermann.gitlab.io/gluon/">HTML documentation is here.</a></p>
<h2>Using gluon</h2>
<p>gluon is a growing collection of simple algorithms, data structures and utilities in C. Due to design restrictions (see below), it is even usable (but not restricted to) small embedded systems, microcontrollers or systems without operating system.</p>
<p>Most modules contain no dependencies or only dependencies to parts of the C standard library. Most modules can be used independently from each other.</p>
<p>Unless otherwise noted, none of the algorithms use dynamic memory allocation or I/O streams, since their use can be problematic in constrained environments.</p>
<p>Some modules have a configuration section in their header files. For example, one configuration option that is often included, is to use a module as "header only library". If active, you only have to include the header file to use the module. Of course, this comes with additional cost; each compilation unit will contain a copy of the included functions.</p>
<p>Some modules contain further configuration defines, see the documentation of specific modules for details.</p>
<p>Usage examples can be found in the accompanying test.c files, that contain unit tests.</p>
<p>Happy hacking...</p>
<h3>List of Modules</h3>
<ul>
<li>32 bit cyclic redundancy check - <a class="el" href="crc32_8h.html">crc32.h</a></li>
<li>Calculate Fletcher 32 checksum - <a class="el" href="fletcher32__checksum_8h.html">fletcher32_checksum.h</a></li>
<li>Calculate Fletcher16 checksum - <a class="el" href="fletcher16__checksum_8h.html">fletcher16_checksum.h</a></li>
<li>Consistent overhead byte stuffing - <a class="el" href="cobs__encode_8h.html">cobs_encode.h</a> <a class="el" href="cobs__decode_8h.html">cobs_decode.h</a></li>
<li>Determine endianess of host system - <a class="el" href="endian__check_8h.html">endian_check.h</a></li>
<li>Encryption/decryption with XTEA cipher - <a class="el" href="xtea__cipher_8h.html">xtea_cipher.h</a></li>
<li>Insertion sort algorithm - <a class="el" href="insertion__sort_8h.html">insertion_sort.h</a></li>
<li>Macros and functions for bit banging - <a class="el" href="bit__hacks_8h.html">bit_hacks.h</a></li>
<li>Macros to check result of arithmetic operations</li>
<li>PID controller - <a class="el" href="pid__controller_8h.html">pid_controller.h</a></li>
<li>Ring buffer (aka circular queue) - <a class="el" href="ring__buffer_8h.html">ring_buffer.h</a></li>
<li>Selection sort algorithm - <a class="el" href="selection__sort_8h.html">selection_sort.h</a></li>
<li>Singly linked list - list.h</li>
</ul>
<h2>Developing gluon</h2>
<h3>Leading Design Principles</h3>
<ul>
<li>Comprehensibility through simplicity and brevity.</li>
<li>Correctness, portability and maintainability through comprehensibility.</li>
<li>Generality</li>
<li>Usability</li>
</ul>
<h3>Coding Rules</h3>
<h4>Design</h4>
<ul>
<li>Use the simplest algorithm that can do the job.</li>
<li>No fancy speed or size optimizations.</li>
<li>Keep in mind limited resources of embedded systems (time and space complexity, capabilities of 8/16/32-bit architectures).</li>
<li>Keep in mind compatibility with little/big endian byte order architectures.</li>
<li>Design public API for easy use and broad range of use cases.</li>
<li>Where possible, make algorithms configurable to work with different data types.</li>
<li>Where possible, provide the optional possibility to use modules as header only library, for ease of use.</li>
<li>If a module needs to maintain state between invocations, use an explicit "this" argument, to enable multiple instances.</li>
<li>No use of dynamic memory allocation (<code>malloc()</code>, <code>alloc()</code>).</li>
<li>No use of I/O streams (<code>FILE</code>, <code>stdin</code>, <code>stdout</code>, <code>stderr</code>).</li>
<li>No usage of language constructs with undefined or unspecified behaviour. Usage of implementation defined behaviour must be documented.</li>
<li>Heavy use of <code>assert()</code>, also for checking the validity of function parameters.</li>
<li>Test/verification coverage of all relevant parts.</li>
<li>Code should be C99 compatible, deviations should be documented.</li>
</ul>
<h4>Code Formatting</h4>
<ul>
<li>File format is UTF-8, Unix file endings (LF), no tabs, 4 spaces for indentation.</li>
<li>Functions should be short, at least as short as the number of lines that can be displayed on a typical monitor.</li>
<li>Lines should be short, at least as short as the number of columns that can be displayed on a typical monitor.</li>
<li><code>if</code>/<code>else</code> branches always use <code>{...}</code> code blocks.</li>
<li>Opening braces (<code>{</code>) of code blocks are placed always on a new line.</li>
<li>Operators and expressions are delimited by spaces (e.g. <code>y = x + 42</code> as opposed to <code>y=x+42</code>).</li>
<li>Pointer declarations have the star next to the variable type (e.g. <code>int32\_t* i</code> as opposed to <code>int32\_t *i</code>).</li>
<li>There are no spaces after opening parentheses (<code>(</code>) or before closing parentheses (<code>)</code>).</li>
<li>No spaces after a function name (e.g. <code>foo()</code>).</li>
<li>Use spaces after keywords, except they look like function calls (e.g <code>if (...)</code>, <code>while (...)</code> but <code>sizeof()</code>.</li>
<li>All names use lower snake_case.</li>
<li>Names document the source code. They should be meaningful for developers reading the code for the first time.</li>
<li>Names should be context sensitive. The general rule is that names get shorter with its degree of locality, since a names context (module or function name) already holds information that does not need to be repeated. As long as necessary, as short as possible.</li>
<li>Use of code comments is regarded as failure to use proper naming.</li>
</ul>
<h2>License and Credits</h2>
<p>Unless otherwise noted in the specific files, all code is licensed under BSD 2-clause, Copyright (c) Ulf Westermann.</p>
<p>gluon uses the great unit test framework <a href="https://github.com/silentbicycle/greatest">greatest</a>, which is licensed under its own terms.</p>
<p>gluon uses the bounded model checker <a href="http://www.cprover.org/cbmc/">CBMC</a> for verification.</p>
<p>Books and resources</p><ul>
<li><a href="http://hackersdelight.org/">http://hackersdelight.org/</a></li>
<li><a href="http://www.algorist.com/">http://www.algorist.com/</a></li>
<li><a href="http://www.numerical.recipes/">http://www.numerical.recipes/</a></li>
<li><a href="http://www.dspguide.com/">http://www.dspguide.com/</a></li>
<li><a href="https://www.embedded.com/user/JackCrens">https://www.embedded.com/user/JackCrens</a></li>
<li><a href="http://cppreference.com/">http://cppreference.com/</a></li>
<li><a href="https://wiki.sei.cmu.edu/confluence/display/c/SEI+CERT+C+Coding+Standard">https://wiki.sei.cmu.edu/confluence/display/c/SEI+CERT+C+Coding+Standard</a> </li>
</ul>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
